#define GL_GLEXT_PROTOTYPES
#include "geometry.h"
#include "state0.h"
#include <GL/glut.h>

#define S state0

void
geometry (GLenum mode)
{
  glMatrixMode (GL_MODELVIEW);
  glLoadIdentity ();
  glPushMatrix ();

  /*
   * Apply the results of any panning operations.
   */
  glTranslatef (S.pan.trans[0], S.pan.trans[1], 0.0);

  /*
   * Draw the map.
   */
  glCallList (S.list_offset + MAP_GEOMETRY);

  glPopMatrix ();

  /*
   * Draw the legend.
   */
  if (S.legend)
    glCallList (S.list_offset + DENSITY_LEGEND_GEOMETRY);

  glCallList (S.list_offset + DATAROSE_GEOMETRY);

  return;
}
